searchNodes=[{"type":"module","title":"Logger.Backends.Sentry","doc":"This module is the sentry backend for Logger and it can handle the event message from the Logger event server and push the log message to the sentry dashboard. This module have a set of interface functions: get/set the log level get/set the log metadata Config Set the configuration for :logger as follow and the Sentry backend will push logging messages to the Sentry dashboard. config :logger , backends : [ :console , Logger.Backends.File ] , sentry : [ level : :error , metadata : [ ] ] Suppressing Sentry logging When you want to suppress Sentry logging for a specific Logger call even if Sentry level is met to the level, pass following option: [ logger_sentry : [ skip_sentry : boolean ] ] For example, if Sentry level is set to :error , and you want to suppress Sentry logging for a specific error logging: Logger . error ( &quot;error msg&quot; , [ logger_sentry : [ skip_sentry : true ] ] )","ref":"Logger.Backends.Sentry.html"},{"type":"function","title":"Logger.Backends.Sentry.level/0","doc":"Get the backend log level.","ref":"Logger.Backends.Sentry.html#level/0"},{"type":"function","title":"Logger.Backends.Sentry.level/1","doc":"Set the backend log level.","ref":"Logger.Backends.Sentry.html#level/1"},{"type":"function","title":"Logger.Backends.Sentry.metadata/0","doc":"Get the backend log metadata.","ref":"Logger.Backends.Sentry.html#metadata/0"},{"type":"function","title":"Logger.Backends.Sentry.metadata/1","doc":"Set the backend log metadata.","ref":"Logger.Backends.Sentry.html#metadata/1"},{"type":"module","title":"LoggerSentry.Fingerprint","doc":"Default fingerprints.","ref":"LoggerSentry.Fingerprint.html"},{"type":"function","title":"LoggerSentry.Fingerprint.fingerprints/3","doc":"Fetch the default fingerprints.","ref":"LoggerSentry.Fingerprint.html#fingerprints/3"},{"type":"module","title":"LoggerSentry.Fingerprint.CodeLocation","doc":"Default fingerprints from code location.","ref":"LoggerSentry.Fingerprint.CodeLocation.html"},{"type":"function","title":"LoggerSentry.Fingerprint.CodeLocation.fingerprints/2","doc":"","ref":"LoggerSentry.Fingerprint.CodeLocation.html#fingerprints/2"},{"type":"module","title":"LoggerSentry.Fingerprint.MatchMessage","doc":"Default fingerprints from match error message.","ref":"LoggerSentry.Fingerprint.MatchMessage.html"},{"type":"function","title":"LoggerSentry.Fingerprint.MatchMessage.fingerprints/2","doc":"","ref":"LoggerSentry.Fingerprint.MatchMessage.html#fingerprints/2"},{"type":"behaviour","title":"LoggerSentry.RateLimiter","doc":"The top-level logic for rate limiting requests. Must be given a LoggerSentry.RateLimiter.Strategy to provide the details of the actual rate-limiting algorithm. The algorithm is specified by the application config. The following example sets a rate limit of 20 requests per minute using the token bucket algorithm. import Config config :logger_sentry , LoggerSentry.RateLimiter , rate_limiter_module : LoggerSentry.RateLimiter.TokenBucket , rate_limiter_options : [ token_count : 20 , interval_ms : 60_000 ] If no strategy is configured, then defaults to the strategy LoggerSentry.RateLimiter.NoLimit. As implied by the name, this doesn't do any rate limiting. You may provide your own rate limiters as long as they conform to the LoggerSentry.RateLimiter behaviour.","ref":"LoggerSentry.RateLimiter.html"},{"type":"callback","title":"LoggerSentry.RateLimiter.check/1","doc":"","ref":"LoggerSentry.RateLimiter.html#c:check/1"},{"type":"function","title":"LoggerSentry.RateLimiter.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LoggerSentry.RateLimiter.html#child_spec/1"},{"type":"function","title":"LoggerSentry.RateLimiter.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"LoggerSentry.RateLimiter.html#init/1"},{"type":"callback","title":"LoggerSentry.RateLimiter.init/1","doc":"","ref":"LoggerSentry.RateLimiter.html#c:init/1"},{"type":"function","title":"LoggerSentry.RateLimiter.send_rate_limited/3","doc":"","ref":"LoggerSentry.RateLimiter.html#send_rate_limited/3"},{"type":"function","title":"LoggerSentry.RateLimiter.start_link/1","doc":"","ref":"LoggerSentry.RateLimiter.html#start_link/1"},{"type":"type","title":"LoggerSentry.RateLimiter.opts/0","doc":"","ref":"LoggerSentry.RateLimiter.html#t:opts/0"},{"type":"type","title":"LoggerSentry.RateLimiter.strategy/0","doc":"","ref":"LoggerSentry.RateLimiter.html#t:strategy/0"},{"type":"module","title":"LoggerSentry.RateLimiter.NoLimit","doc":"","ref":"LoggerSentry.RateLimiter.NoLimit.html"},{"type":"module","title":"LoggerSentry.RateLimiter.Strategy","doc":"A struct holding common data for rate-limiting strategies. The module must be the name of a module that conforms to the LoggerSentry.RateLimiter behaviour. The state may be used however the module sees fit.","ref":"LoggerSentry.RateLimiter.Strategy.html"},{"type":"function","title":"LoggerSentry.RateLimiter.Strategy.new/2","doc":"","ref":"LoggerSentry.RateLimiter.Strategy.html#new/2"},{"type":"type","title":"LoggerSentry.RateLimiter.Strategy.t/0","doc":"","ref":"LoggerSentry.RateLimiter.Strategy.html#t:t/0"},{"type":"module","title":"LoggerSentry.RateLimiter.TokenBucket","doc":"An implementation of a token bucket rate-limiting strategy. Essentially, in some time period (ex. one minute), there are X number of tokens available. One request consumes one token. If no tokens, then no more requests may run. After the time interval has elapsed, the token count is restored to max.","ref":"LoggerSentry.RateLimiter.TokenBucket.html"},{"type":"module","title":"LoggerSentry.Sentry","doc":"Generate options for sentry.","ref":"LoggerSentry.Sentry.html"},{"type":"function","title":"LoggerSentry.Sentry.generate_opts/2","doc":"Generate options for sentry.","ref":"LoggerSentry.Sentry.html#generate_opts/2"},{"type":"extras","title":"License","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html"},{"type":"extras","title":"Overview","doc":"The Logger backend for Sentry .","ref":"readme.html"},{"type":"extras","title":"Overview - Installation","doc":"The package can be installed as: Add :logger_sentry to your mix.exs file: def deps do [ { :logger_sentry , &quot;~&gt; 0.8.0&quot; } ] end Configure your config file, just like: config :logger , backends : [ :console , Logger.Backends.Sentry ] , sentry : [ level : :error , metadata : [ :application , :module , :function , :file , :line , :pid ] # :all ] If you want keep :console backend in Logger event server, you should set :backends with [:console, Logger.Backends.Sentry] . Just like :console backend, the sentry backend supports the same :level and :metadata options.","ref":"readme.html#installation"},{"type":"extras","title":"Overview - Usage","doc":"Similar to Logger . Logger . debug ( &quot;this is one debug message&quot; ) Logger . info ( &quot;this is one info message&quot; ) Logger . warning ( &quot;this is one warning message&quot; ) # if you set sentry logger level with `:error`, the message will sent to your # sentry server Logger . error ( &quot;this is one error message&quot; ) Get log level Logger.Backends.Sentry . level Set log level Logger.Backends.Sentry . level ( :error ) Get metadata Logger.Backends.Sentry . metadata Set metadata Logger.Backends.Sentry . metadata ( [ ] ) Logger.Backends.Sentry . metadata ( :all ) Logger.Backends.Sentry . metadata ( [ :application , :module , :pid ] )","ref":"readme.html#usage"},{"type":"extras","title":"Overview - Fingerprints","doc":"To use fingerprints in sentry dashboard, set :logger_sentry option to define generate fingerprints modules: config :logger_sentry , fingerprints_mods : [ LoggerSentry.Fingerprint.MatchMessage , LoggerSentry.Fingerprint.CodeLocation , MyApp.Fingerprint.MyModule ] Only match error message, LoggerSentry.Fingerprint.MatchMessage and code location, LoggerSentry.Fingerprint.CodeLocation are available by default right now. You can define your own module, for example, MyApp.Fingerprint.MyModule , by adding a fingerprints/2 function.","ref":"readme.html#fingerprints"},{"type":"extras","title":"Overview - Examples","doc":"See additional usage examples at wiki .","ref":"readme.html#examples"},{"type":"extras","title":"Overview - Rate Limiting","doc":"Sentry can be configured with a rate limit on the Sentry servers. Any messages received faster than that limit will not be processed. In order to avoid unnecessary traffic and potentially getting IP-blocked by Sentry, it is recommended to add rate limiting on your own servers. By default, LoggerSentry does not enforce rate limits. Rate limiting can be added through your project config files like this: import Config config :logger_sentry , LoggerSentry.RateLimiter , rate_limiter_module : LoggerSentry.RateLimiter.TokenBucket , rate_limiter_options : [ token_count : 20 , interval_ms : 60_000 ] LoggerSentry comes with a simple token bucket algorithm. You may add other rate-limiting algorithms by creating a module that conforms to the LoggerSentry.RateLimiter module. Then setting rate_limiter_module to your custom module.","ref":"readme.html#rate-limiting"},{"type":"extras","title":"Overview - Copyright and License","doc":"Copyright (c) 2017 Taotao Lin Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license"}]